<?php
require("./init.php");
// check if user is logged in
if (!session_is_registered("userid"))
{
    $template->assign("loginerror", 0);
    $template->display("login.tpl");
    die();
}
// create message object
$msg = new message();
$objmilestone = (object) new milestone();
// get data from POST and GET
// getArrayVal will return the value from the array if present, or false if not. This way the variable is never undeclared.
$action = getArrayVal($_GET, "action");
$id = getArrayVal($_GET, "id");
$mid = getArrayVal($_GET, "mid");
$mode = getArrayVal($_GET, "mode");
$thefile = getArrayVal($_POST, "mode");
$numfiles = getArrayVal($_POST, "numfiles");
$userfile = getArrayVal($_POST, "userfiles");
$tags = getArrayVal($_POST, "tags");

$message = getArrayVal($_POST, "text");
$title = getArrayVal($_POST, "title");
$mid_post = getArrayVal($_POST, "mid");
$text = getArrayVal($_POST, "text");
$milestone = getArrayVal($_POST,"milestone");

$project = array('ID' => $id);
$template->assign("project", $project);
$template->assign("mode", $mode);
// define the active tab in the project navigation
$classes = array("overview" => "overview", "msgs" => "msgs_active", "tasks" => "tasks", "miles" => "miles", "files" => "files", "users" => "users", "tracker" => "tracking");
$template->assign("classes", $classes);

if ($action != "mymsgs")
{
	//check if the user belongs to the current project. die if he/she doesn't
    if (!chkproject($userid, $id))
    {
        $errtxt = $langfile["notyourproject"];
        $noperm = $langfile["accessdenied"];
        $template->assign("errortext", "$errtxt<br>$noperm");
        $template->display("error.tpl");
        die();
    }
}

if ($action == "addform")
{
    // display addform
    $template->display("addmessageform.tpl");
} elseif ($action == "add")
{
    // format tags properly
    $tagobj = new tags();
    $tags = $tagobj->formatInputTags($tags);
    // add message

    $themsg = $msg->add($id, $title, $message, $tags, $userid, $username, 0, $milestone);

    if ($themsg)
    {
        if ($thefiles > 0)
        {
            // if upload files are set, upload and attach
            $msg->attachFile($thefiles, $themsg);
        } elseif ($thefiles == 0 and $numfiles > 0)
        {
            // else just attach existing file
            $msg->attachFile(0, $themsg, $id);
        }
        $loc = $url . "managemessage.php?action=showproject&id=$id&mode=added";
       header("Location: $loc");

    }
} elseif ($action == "editform")
{
    // get the page title from the language file
    $title = $langfile['editmessage'];
    $template->assign("title", $title);
    // get the message to edit
    $message = $msg->getMessage($mid);
    $template->assign("message", $message);
    $template->display("editmessageform.tpl");
} elseif ($action == "edit")
{
    $tagobj = new tags();
    $tags = $tagobj->formatInputTags($tags);
    // edit the msg
    if ($msg->edit($mid_post, $title, $text, $tags))
    {
        if ($redir)
        {
            $redir = $url . $redir;
            header("Location: $redir");
        }
        else
        {
            $loc = $url . "managemessage.php?action=showproject&id=$id&mode=edited";
            header("Location: $loc");
        }
    }
} elseif ($action == "del")
{
	//delete the message
    if ($msg->del($mid))
    {
    	//if a redir target is given, redirect to it. else redirect to standard target.
        if ($redir)
        {
            $redir = $url . $redir;
            header("Location: $redir");
        }
        else
        {
            $loc = $url . "managemessage.php?action=showproject&id=$id&mode=deleted";
            header("Location: $loc");
        }
    }
} elseif ($action == "replyform")
{
    $title = $langfile['reply'];
    $template->assign("title", $title);
    $myfile = new datei();
    $ordner = $myfile->getProjectFiles($id, 1000);
    $message = $msg->getMessage($mid);
    $template->assign("message", $message);
    $template->assign("files", $ordner);
    $template->display("replyform.tpl");
} elseif ($action == "reply")
{
    $tagobj = new tags();
    $tags = $tagobj->formatInputTags($tags);
    $themsg = $msg->add($id, $title, $message, $tags, $userid, $username, $mid_post);
    if ($themsg)
    {
        if ($thefiles > 0)
        {
            $msg->attachFile($thefiles, $themsg);
        } elseif ($thefiles == 0 and $numfiles > 0)
        {
            $msg->attachFile(0, $themsg, $id);
        }
        $loc = $url . "managemessage.php?action=showmessage&mid=$mid_post&id=$id&mode=replied";
        header("Location: $loc");
    }
} elseif ($action == "mymsgs")
{
	//create new project and file objects
    $project = new project();
    $myfile = new datei();
    //get all uof the users projects
    $myprojects = $project->getMyProjects($userid);
    $cou = 0;
    $messages = array();

    //loop through the projects and get messages and files for each project
    foreach($myprojects as $proj)
    {
        $message = $msg->getProjectMessages($proj[0]);
        $ordner = $myfile->getProjectFiles($proj[0], 1000);
	$milestones = $objmilestone->getProjectMilestones($proj[0], 10000);
	
	$myprojects[$cou]["milestones"] = $milestones;
        $myprojects[$cou]["messages"] = $message;
        $myprojects[$cou]["files"] = $ordner;
        $cou = $cou + 1;
    }

    $title = $langfile['messages'];
    $template->assign("title", $title);
    $template->assign("myprojects", $myprojects);
    $template->display("mymessages.tpl");
} elseif ($action == "showproject")
{
	//check if user is a normal user adminstate = 0 is client usr.
    if ($adminstate < 1)
    {
        $errtxt = $langfile["nopermission"];
        $noperm = $langfile["accessdenied"];
        $template->assign("errortext", "$errtxt<br>$noperm");
        $template->assign("mode", "error");
        $template->display("error.tpl");
        die();
    }
    //get all messages of this project
    $messages = $msg->getProjectMessages($id);

	//get project's name
	$myproject = new project();
    $pro = $myproject->getProject($id);
    $projectname = $pro['name'];
    $template->assign("projectname", $projectname);

	//get the page title
	$title = $langfile['messages'];
    $template->assign("title", $title);

    if (!empty($messages))
    {
        $mcount = count($messages);
    }
    else
    {
        $mcount = 0;
    }
    //get files of the project
    $datei = new datei();
    $thefiles = $datei->getProjectFiles($id);

    $milestones = $objmilestone->getProjectMilestones($id, 10000);
    
    $template->assign("milestones", $milestones);
    $template->assign("projectname", $projectname);
    $template->assign("files", $thefiles);
    $template->assign("messages", $messages);
    $template->assign("messagenum", $mcount);
    $template->display("projectmessages.tpl");
} elseif ($action == "showmessage")
{
	//get the message and it's replies
    $message = $msg->getMessage($mid);
    $replies = $msg->getReplies($mid);

    $myproject = new project();
    $pro = $myproject->getProject($id);
    $myfile = new datei();
    $ordner = $myfile->getProjectFiles($id);

    $projectname = $pro['name'];
    $title = $langfile['message'];


    $template->assign("projectname", $projectname);
    $template->assign("title", $title);
    $template->assign("mode", $mode);
    $template->assign("message", $message);
    $template->assign("ordner", $ordner);
    $template->assign("replies", $replies);
    $template->display("message.tpl");
}
?>